=== src/extra/filter-c/Makefile ===
CFLAGS = -Wall -Wshadow -O3 -g -march=native
LDLIBS = -lm

example: example.o filter.o

clean:
	$(RM) *.o
	$(RM) example filter *.exe
